//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------
 
#include "dictionary.h"
#include "tokenizer.h"
#include "mytemplate.h"
#include "stringbuffer.h"

#pragma argsused





//             ****  TEST template class ***
int main(int argc, char* argv[])
{

   

 // printf("%d\n", strcmp("a","b"));

  printf("---------test DArray-------\n");
  DArray<int> a(32);
  for( int j = 0; j < 64; j++)
   a[j] = j;
  for(int j = 0; j < a.cnt; j++)
   printf("%d ", a[j]);
  printf("\n");

  a.Fill(0);

  for(int j = 0; j < a.cnt; j++)
   printf("%d ", a[j]);
  printf("\n");


  printf("---------test DStack-------\n");
  DStack<int> stack(4);
  for(int j = 0; j < 32; j++)
      stack.Push(j);
  while(!stack.IsEmpty())
    printf("%d ", stack.Pop());
  printf("\n");

  printf("---------test DQueue-------\n");
  DQueue<int> q(4);
  for(int j = 0; j < 32; j++)
      q.Put(j);
//  for(int j = 0; j < 32; j++)
//      printf("%d ", q.a[j]  );
  while(!q.IsEmpty())
    printf("%d ", q.Get());
  printf("\n");




  printf("----------test DArrayList----------\n");
  DArrayList<int> al(4);
  for(int j = 0; j < 16; j++)
      al.AddEnd(j);

  al.RemoveElementAt(al.Size()/2);
  al.Last() = -1;
  al.First() = -1;
  al.RemoveFirst();
  al.RemoveLast();
  for(int j = 0; j < al.Size(); j++)
      printf("%d ", al[j]  );

  printf("\n");


  printf("----------test DArrayList----------\n");
  DArrayList<char*> foo(4);

  for(int j = 'z'; j >= 'a'; j--)
  {
     char *s = new char[2];
     s[0] = j;
     s[1] = 0;
     foo.AddFront(s);
  }
 
  foo.QSort(0,foo.Size()-1, cmp_default);
  for(int j = 0; j < foo.Size(); j++)
   printf("%s\n", foo[j]);
  printf("search %s index: %d\n", foo[7], foo.BinSearch(foo[7],cmp_default));


  printf("----------test DString----------\n");
  DString s(4);

  s = "hello";
  if(s == "hello"){
    s += " world! \r\n ";
    s.Trim();
    printf("%s\n", s.UpperCase());
  }

  printf("enter string or Cntrl-Z (end text file)\n");
  StringTokenizer *t = new StringTokenizer(s.CStr(),DELIMITERS_DEFAULT);
  while( s.FGets(stdin)){
    // s.Trim();
    // s.FPuts(stdout);
     t->SetStr(s.CStr()); 
     char *p;
     while( (p = t->nextToken()) != NULL )
     {
       printf("%-10s  %s\n", p, t->CharIsDel(*p)?"delimiter":"");
     }
  }
  delete t;
//  delete s;

  system("PAUSE");
  //////////////////////////
  return 0;
}



/*
//             ****  TEST class Dictionary ***
int main(int argc, char* argv[])
{
   char del[] = "[](),.!@#$%^&?*-=+\\//;:\"'<>";
   char text[] = "\
begin                                        \n\
 int foo[20];                                \n\
 for(int j = 0; j < 20; j++)                 \n\
   foo[j] = j;                               \n\
end";



   StringTokenizer *t = new StringTokenizer(text,del);
   char *p;
   while( (p = t->nextToken()) != NULL )
   {
     printf("%-10s  %s\n", p, t->CharIsDel(*p)?"delimiter":"");
   }

   getc(stdin);
   return 0;
}
*/

/*************** output **************
begin
int
foo
[           delimiter
20
]           delimiter
;           delimiter
for
(           delimiter
int
j
=           delimiter
0
;           delimiter
j
<           delimiter
20
;           delimiter
j
+           delimiter
+           delimiter
)           delimiter
foo
[           delimiter
j
]           delimiter
=           delimiter
j
;           delimiter
end
*/




/*

int main(int argc, char* argv[])
{

   //             ****  TEST class Dictionary ***
   Dictionary *d = new Dictionary();

   d->Add( strdup("Moskow"), strdup("Russia"));
   d->Add( strdup("St-Peterburg"), strdup("Russia"));

   for( int i = 0; i < d->cnt; i++)
    printf("%s=%s\n", d->GetElementAt(i)->key, d->GetElementAt(i)->value);


   printf("-------------\n");

   for( HNode *p = d->list; p; p = p->nextAll )
     printf("%s=%s\n", p->key, p->value);


   printf("------save & load-------\n");
   d->Save("dict.txt");
   delete d;
   d = new Dictionary();
   d->Load("dict.txt");
   for( HNode *p = d->list; p; p = p->nextAll )
     printf("%s=%s\n", p->key, p->value);

   delete d;

   getc(stdin);
   return 0;
}
   */

//---------------------------------------------------------------------------
