//---------------------------------------------------------------------------

#ifndef dictionaryH
#define dictionaryH

#include "myutils.h"
/*
   @author Korniloff E.
   @version 1.00 2007
*/

/*
       - 
       2 
  KeyEquale -  
  KeyHashCode -  - 
*/


struct HNode{ //  

  void *key, *value;  //  - ,  
  int index; // -    0..inf

  THashKey key_hash_code; //-  -    
  HNode *nextAll; //  


  HNode( void* key, void *value, THashKey key_hash_code, int index ){
    this->key = key;
    this->value = value;
    this->key_hash_code = key_hash_code;
    this->index = index;
    nextSub = nextAll = nextIndex = 0;
  }

   // private
   HNode *nextSub, // -    
         *nextIndex; // -     
};

#define H_TBL_CNT (1<<16)

//   -     - 
//    !!!
//    0..inf
class Dictionary{
 public:
  HNode *list; //  
  int cnt;     //  -


  Dictionary(); 
  Dictionary( bool (*KeyEqual)(void *key1, void *key2),
             THashKey (*KeyHashCode)(void *key),
             void (*WriteElement)(HNode *node, FILE *f),
             bool (*ReadElement)(HNode *node, FILE *f)
             );

  ~Dictionary();           
  HNode* Look(void *key);
  HNode* Add(void *key, void *value);
  HNode* GetElementAt(int index); // HNode   index (,  Look)
  bool Save(char fname[]);
  bool Load(char fname[]);
 protected:
  HNode *tbl[H_TBL_CNT];  //     
  HNode *tbl_index[32];   //    -   GetElementAt
  bool (*KeyEqual)(void *key1, void *key2); //  -  
  THashKey (*KeyHashCode)(void *key);
  void (*WriteElement)(HNode *node, FILE *f);
  bool (*ReadElement)(HNode *node, FILE *f);

  HNode **Entry(void *key){  //  -
    return (HNode**) &tbl[KeyHashCode(key) & (H_TBL_CNT-1)];
  }
  HNode **last; //    list
};

//if key & value is char[]
bool KeyEqualDefault(void *key1, void *key2);
THashKey KeyHashCodeDefault(void *key);
void WriteElementDefault(HNode *node, FILE *f);
bool ReadElementDefault(HNode *node, FILE *f);





//---------------------------------------------------------------------------
#endif
