//---------------------------------------------------------------------------

#ifndef mytemplateH
#define mytemplateH

#include "myutils.h"

/*
   @author Korniloff E.
   @version 1.01 2007
*/


//   
template < class T >
 class DArray{
  public:
   T *data;
   int size;
   int cnt;

   DArray(){
      size = 1;
      data = (T*)malloc(sizeof(T)*size);
      cnt  = 0;
   }
   DArray(int min_size){    //  
      size = P2(min_size);
      data = (T*)malloc(sizeof(T)*size);
      cnt  = 0;
   }
   ~DArray(){
     if(data) free(data);
   }
   T& operator[] (int index){  //   -  
      if(index >= size){
          size = P2(index+1);
          data = (T*)realloc(data,sizeof(T)*size);
      }
      if(index >= cnt) cnt = index + 1;
      return data[index];
   }
   void AllocMem(int new_size){
      if(new_size > size){
          size = P2(new_size);
          data = (T*)realloc(data,sizeof(T)*size);
      }
   }
   void Fill(int c){     //   <c>
     memset(data,c,sizeof(T)*size);
   }
 //  void Reset(){
 //     cnt = 0;
 //  }

 };

//     
//      DArray  , DArray.cnt -   
//   -  
template <class T>
  class DStack{
   public:
    DArray<T> a;  // !!!   top 
    int top;

    DStack(int min_size):a(min_size){   //  - 
      top = 0;
    }
    DStack():a(1){   //  - 
      top = 0;
    }
    bool IsEmpty(){ return top <= 0; }  //?
    T Push(T value) {                   //  
      a[top] = value;
      top++;
      return value;
    }
    T Pop(){
      top--;                            //  
      return a[top];
    }
    T Last(){
       return a[top-1];
    }
  };


//     
//   -  
template <class T>
  class DQueue{
   public:
    DArray<T> a; // !!!   top 
    int top;

    DQueue(int min_size):a(min_size){ // -  - 
      top = 0;
    }
    bool IsEmpty(){ return top <= 0; }  // ?
    T Put(T value) {                    //  
      a[top] = value;
      top++;
      return value;
    }
    T Get(){                            //  
      T tmp = a.data[0];
      if( top > 1 )
        memmove( a.data, a.data+1, sizeof(T) * (top-1) );
      top--;
      return tmp;
    }
    T Pop(){                //    (  ) -    :))
      top--;
      return a[top];
    }

  };


//     .
// ,       
//        
//     
//  
//      

int cmp_default(   char *s1 ,  char *s2 );

template <class T>
  class DArrayList{
   public:
/**/DArrayList(int min_size):a(min_size){ // -  - 
      cnt = 0;
    }
/**/DArrayList():a(1){ // -  - 
      cnt = 0;
    }
/**/int Size() { return cnt; }          //- 
/**/bool IsEmpty(){ return cnt <= 0; }  //  ?
/**/void Resize(int new_cnt){
      a.AllocMem( new_cnt * sizeof(T));
      cnt = new_cnt;
    }
/**/T AddEnd(T value) {                 //  
      a[cnt] = value;
      cnt++;
      return value;
    }
/**/T AddFront(T value) {               //  
      a[cnt] = value;//  1 
      cnt++;
      if( cnt > 1 ){
        memmove( a.data + 1, a.data, sizeof(T) * (cnt-1) );
        a[0] = value;
      }
      return value;
    }

/**/T RemoveElementAt(int index){   //  
      T tmp = a.data[index];
      if( cnt - index - 1  > 0 )
        memmove( a.data + index, a.data+index+1, sizeof(T) * (cnt - index - 1) );
      cnt--;
      return tmp;
    }
/**/T InsertElementAt(T value, int index){ //  
      a[cnt] = value;
      cnt++;
      if( cnt - index - 1 > 0 )
        memmove( a.data + index + 1, a.data+index, sizeof(T) * (cnt - index - 1) );

      a[index] = value;
      return value;
    }
/**/void RemoveAll() { cnt = 0; }  //  
/**/T RemoveLast(){                //    (  )
      cnt--;
      return a[cnt];
    }
/**/T RemoveFirst(){ return  RemoveElementAt(0); } // 
/**/T& operator[]  ( int index) { return a[index]; } //  
/**/T& Last()      { return  a[cnt-1]; }   //  
/**/T& First()     { return  a[0]; }       //  

/**/void Swap(int k1, int k2){
      T tmp = a[k1];
      a[k1] = a[k2];
      a[k2] = tmp;
    }

/**/void Sort(int low, int high, int (*objcmp)( T  , T )  );
/**/void QSort(int low, int high, int (*objcmp)( T  , T )  );
    void QSort(int (*objcmp)( T  , T )  ){
        QSort(0, Size()-1, objcmp);
    }
/**/int BinSearch(T obj,   int (*objcmp)( T  , T ) );// index 0..size-1  or -1
/**/int InsertInSortOrder(T obj,   int (*objcmp)( T  , T ) );

    protected:     //     
      DArray<T> a; // !!!   cnt  -   <a>   , .    
      int cnt;
  };

/////////  IMPLEMENTATION DArrayList /////////////

template <class T>
void DArrayList<T>::Sort(int low, int high, int (*objcmp)( T  , T )  ){ //objcmp like  strcmp
      int find;
      do{
        find = 0;
        for(int j = low; j < high; j++)
          if( objcmp( a[j],a[j+1] ) > 0 )
          {
            find = 1;
            Swap(j+1,j);
          }
      }while( find &&  --high > low);
    }

template <class T>
void DArrayList<T>::QSort(int low, int high, int (*objcmp)( T  , T )  ){

      if( high - low < 20 ){
        if(high - low >= 0)
           Sort(low,high,objcmp);
      }else{
        int k = low;
        int j = low;
        T t = a[ low + (high-low)/2];
        for(; j <= high; j++)
         if(objcmp(a[j],t) < 0 ){
           Swap(k,j);
           k++;
         }
        QSort(low,k-1,objcmp);
        QSort(k,high,objcmp);
      }
    }

template <class T>
int DArrayList<T>:: BinSearch(T obj,   int (*objcmp)( T  , T ) ){ // -    
      int low = 0;
      int high = Size()-1;
      while( high - low > 5 ){
        int k = (high + low)/2;
        int cmp = objcmp(obj,a[k]);
        if(cmp > 0){
           low = k + 1;
        }else if(cmp < 0){
           high = k-1;
        }else return k;
      }

      for(int k = low; k <= high; k++)
       if( objcmp(a[k],obj)==0 ) return k;

      return -1;
    }

template <class T>
int DArrayList<T>:: InsertInSortOrder(T obj,   int (*objcmp)( T  , T ) ){
      int low = 0;
      int high = Size()-1;
      while( high - low > 5 ){
        int k = (high + low)/2;
        int cmp = objcmp(obj,a[k]);
        if(cmp > 0){
           low = k + 1;
        }else if(cmp < 0){
           high = k-1;
        }else break;
      }

      for(int k = low; k <= high; k++)
       if( objcmp(a[k],obj) > 0 ){
           InsertElementAt(obj,k);
           return k;
         }

      InsertElementAt(obj,high+1);
      return high+1;
    }



//---------------------------------------------------------------------------
#endif
