//---------------------------------------------------------------------------
// ver. 1.01
#pragma hdrstop

#include "myutils.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

bool SetIn(byte set[], char ch) { return In(set,(byte)ch); }
void SetInclude(byte set[], char ch) { Set(set,(byte)ch); }
void SetExclude(byte set[], char ch) { ReSet(set,(byte)ch); }
int max(int v1, int v2) { return v1>v2?v1:v2; }
int min(int v1, int v2) { return v1<v2?v1:v2; }


void Clear( void* data, int dataSize){

  memset(data,0,dataSize);
}

int SetSizeOf(int maxElements){
  int N = (unsigned)maxElements/8;
  if( (unsigned)maxElements%8 != 0 ) N += 1;

  return N;
}

void Set(byte data[], int N){

  data[ N>>3 ] |= 1 << ( N&7 );
}

void ReSet(byte data[], int N){

  data[ N>>3 ] &= ~(1 << ( N&7 ));
}

bool In(byte data[], int N){

  return (data[ N>>3 ] & (1 << ( N&7 ))) != 0;
}

void SetInitStr( char set[], int maxElements, char del[]){
  int j;
  int N = SetSizeOf(maxElements);

  for(j = 0; j < N; j++) set[j] = 0;
  for(j = 0; del[j]; j++)
   Set((byte*)set, (byte) del[j]);
}

/*   ,  */
char *GetWord( FILE *f ){
 const int N_LEX = 10000;
 static char buf[N_LEX+1];
 int k = 0 ,ch;

 while ( (ch = fgetc(f)) != EOF  &&  MyIsSpace(ch) ); //skip spaces
 if(ch == EOF) return NULL;

 buf[k++] = ch;
 while ( (ch = fgetc(f)) != EOF  &&  !MyIsSpace(ch) )  // read word
   if( k < N_LEX ) buf[k++] = ch;

 buf[k] = '\0';

 if(k == 0) return NULL;
 return buf;

}

/*        ,   - NULL */
char** FileToWords( char fname[],
                     char* (*GetWord)( FILE *f ) //  
                  )
{
  FILE *f;
  int cnt_words = 0;
  char **array = NULL;



  if( (f = fopen(fname,"r")) != NULL ){

     while( GetWord(f) ) cnt_words++;   //- 
     fclose(f);

     array = (char**)calloc( cnt_words + 1, sizeof(char*));
    // array = new char*[cnt_words + 1];
     if(array)
     {
       char *word;
       int k = 0;

       f = fopen(fname,"r");
       while( (word = GetWord(f)) != NULL )
         array[k++] =  strdup(word);
       fclose(f);
       array[k] = NULL;
     }
  }
  return array;
}


THashKey GetStrHashKey(char s[]){
     THashKey key = 0;
     while(*s){
        key = key*31 + (unsigned char)(*s);
        s++;
     }
     return key;
}


char* Trim(char s[]){
   char *p1,*p2;

   for(p1 = s; *p1 && MyIsSpace(*p1); p1++);  //  

   for(p2 = p1; *p2; p2++); // to end

   for(p2--; p2 >= p1  &&  MyIsSpace(*p2); p2--); //  
   p2++;
   *p2 = '\0';

   if(p1 != s)
   {
     char *tmp = s;
     while(*p1) *tmp++ = *p1++;
     *tmp = '\0';
   }

   return s;
}

//    2,  i
int P2( int i ){
  int j;
  //if( (i & (i-1)) == 0 ) return i;
  for(j = 0; j < 30; j++)
    if( (1<<j) >= i ) return 1 << j;

  return i*2;
}

/////////   ////////////////
const unsigned char cyr_chars_low[] ="";
const unsigned char cyr_chars_high[]="";
static int cyr_init = 0;

static int cyr1[256],cyr2[256];
static void CyrInit(void){
  int j;
  for(j = 0; j < cyr_chars_low[j]; j++)
  {
     cyr1[ cyr_chars_low[j]] =  cyr_chars_high[j];
     cyr2[ cyr_chars_high[j]] = cyr_chars_low[j];
  }
}


int ToLower(int ch){
   if(!cyr_init){
     cyr_init = 1;
     CyrInit();
   }
   if(( unsigned char)ch < 128) return tolower(ch);
   else if( cyr2[ (unsigned char) ch] )
     return cyr2[ (unsigned char) ch];
   else return (unsigned char)ch;
}

int ToUpper(int ch){
   if(!cyr_init){
     cyr_init = 1;
     CyrInit();
   }
  // if(ch == '') return '';
  // else return ch;
   //else return toupper(ch);

   if(( unsigned char)ch < 128) return toupper(ch);
   else if( cyr1[ (unsigned char) ch] )
     return cyr1[ (unsigned char) ch];
   else return (unsigned char)ch;

}


/*
  INPUT
    3-    
    ,    
       Cntrl-Z ( )
*/


void INPUT( char message[], char  format[],  void *arg1,void *arg2,void *arg3 ){
  const char input_error[] = "\
    enter correct arguments\n\
    or Cntrl-Z (end of the file)\n";
  char buf[1024];
  int cnt=0, cnt_error = 0, k;
  char *p;


  for(p = format; *p; p++) if( *p == '%' ) cnt++;
  do{
    printf("%s ", message);
    for(k = 0; k <= cnt_error; k++) printf("?");
    printf(" ");
    buf[0] = 0;
    if(fgets(buf,1023,stdin)==NULL) exit(1);
    if(sscanf(buf,format,arg1,arg2,arg3)==cnt) return;
    cnt_error++;
    if(cnt_error == 3)  printf("%s\n", input_error);

  }while(1);
}





char *ExtractFileName(char *path){
  int len = strlen(path);
  for( char *s = path + len - 1;
       s >= path;
       s-- )
  {
     if( *s == DIR_DEL ) return s+1; // file name
  }
  return path + len; // empty string <"">
}

char *ExtractFilePath(char *path){

   *ExtractFileName(path) = '\0';
   return path;

}

int MyIsSpace(int c){
  if( (unsigned char)c < ' ' ) return 1;
  return 0;
}
