//---------------------------------------------------------------------------

#pragma hdrstop
#include "tokenizer.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)


StringTokenizer::  StringTokenizer(char str[]){
    memset(this,0,sizeof(StringTokenizer));
    LexemAllocMem();
    SetStr(str);
  }

StringTokenizer::  StringTokenizer(char str[], char del[]){
    memset(this,0,sizeof(StringTokenizer));
   // SetInitStr( this->delimiters, 256, delimiters);
    SetDelimiters(del);
    LexemAllocMem();
    SetStr(str);
  }

StringTokenizer::  ~StringTokenizer(){
     free( lexem );
     if(back_lexem) free(back_lexem);

  }


  char* StringTokenizer::SetStr(char str[]){
    input_str = str;
    ptr = input_str;
    ClearBackLexem();
    return ptr;
  }

  void StringTokenizer::SetDelimiters(char del[]){
    SetInitStr( this->delimiters, 256, del);
    ClearBackLexem();
  }

  char* StringTokenizer::nextToken(){
    int j = 0;

    if(IsBackLexem()){
       strcpy(lexem,back_lexem);
       ClearBackLexem();
       return lexem;
    }
    while(*ptr != '\0' &&  MyIsSpace(*ptr) && !CharIsDel(*ptr)) ptr++;

    if(*ptr != '\0')
    {
      if(CharIsDel(*ptr)){
        Put(j,*ptr);
        ptr++;
        j++;

      }else{
        while(*ptr != '\0' && !MyIsSpace(*ptr) && !CharIsDel(*ptr))
        {
          Put(j,*ptr);
          ptr++;
          j++;
        }
      }
    }
    Put(j,'\0');

    if(j == 0) return NULL;
    return lexem;
  }


    void StringTokenizer::LexemAllocMem(){
      if(lexem_size==0){
        lexem_size = 32;
        lexem = (char*)malloc(lexem_size);
      }else{
        lexem_size *= 2;
        lexem = (char*)realloc( lexem, lexem_size);
      }
    }

    void StringTokenizer::Put(int index, char ch){
       if(index >= lexem_size) LexemAllocMem();
       lexem[index] = ch;
    }
    bool StringTokenizer::CharIsDel(char ch){
       return SetIn((byte*)delimiters,(byte)ch) != 0;
    }


    void StringTokenizer::BackLexemAllocMem(){
        if(back_lexem_size < lexem_size){
           if(back_lexem==NULL)
              back_lexem = (char*)malloc(lexem_size);
           else
              realloc(back_lexem,lexem_size);
           back_lexem_size = lexem_size;
        }
    }


    char *StringTokenizer::PutBack(){
        BackLexemAllocMem();
        strcpy(back_lexem,lexem);
        return back_lexem;
    }

    void StringTokenizer::ClearBackLexem(){
       if(back_lexem) back_lexem[0] = '\0';

    }
    bool StringTokenizer::IsBackLexem(){

       if(back_lexem && back_lexem[0] != '\0')
         return true;
       return false;  

    }
